#include <bits/stdc++.h>
using namespace std;

int bolji_log(int n){
	int log = -1;
	while (n){
		n = n>>1;
		log++;
	}
	return log;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie();
	int N, Q; cin >> N >> Q;
	int A[N];
	for (int i = 0; i < N; i++){
		cin >> A[i];
		A[i] = bolji_log(A[i]);
	}
	int maksimalni;
	while(Q--){
		int L, R; cin >> L >> R;
		L--; R--;
		int drveta[30] = {};
		for (int i = L; i <= R; i++){
			drveta[A[i]]++;
		}
		maksimalni = 0;
		for(int i = 0; i < 30; i++){
			maksimalni = max(maksimalni, drveta[i]);
		}
		cout << maksimalni << '\n';
		
	}
	


return 0;
}